import { ConnectFunction, OutEnvelope, SocketListener } from "./pingingwebsocket";
declare type State = "connecting" | "connected" | "waiting to reconnect" | "closed";
export declare const reconnectDelayMs = 10000;
export declare class ReconnectingWebSocket {
    private readonly connectFunction;
    private readonly listener;
    private socket?;
    private reconnectHandle?;
    private hadSuccess;
    constructor(connectFunction: ConnectFunction, listener: SocketListener);
    readonly state: State;
    readonly ravenTags: {
        readyState: number | undefined;
        state: State;
    };
    reconnect: () => Promise<void>;
    send(message: OutEnvelope): void;
    close(): void;
    private destroySocket;
}
export {};
